<?php

include '../../core.php';

checkAuth("pkiAdmin");

cabecera (3);

// El siguiente script valida los datos del formulario.
echo "<script language='JavaScript'>
<!--
function submit_form() {

   if (document.newRa_form.ra_url_name.value == '' || 
       document.newRa_form.ra_url_name.value.search(/[^a-z,A-Z,0-9,\_,\-]/i) >= 0) {
      alert ('Por favor introduzca una URL correcta. Solo puede escribir caracteres de la \'a\' a la \'z\', n&uacute;meros y los signos \'-\' y \'_\'');
      document.newRa_form.ra_url_name.focus();
      return false;
   }
   if (document.newRa_form.ra_pass.value != document.newRa_form.ra_retype_pass.value) {
      alert ('Las claves no coinciden');
      document.newRa_form.ra_pass.focus();
      return false;
   }
			   
   document.newRa_form.submit();
   return true;
}
// -->
</script>";
		
echo "<h1 class='title'>Creaci&oacute;n de nueva Autoridad de Registro</h1>";

$command = $_POST["command_newra"];
$errorCode = "a0";

switch ( $command ) {
   default :
      echo "<div id='tbox'>
         <h3 class='head_a2b1'>Datos de la nueva RA</h3>
            <div id='tbox_data_a1'>
      	    <form method='post' action='newRa.php' name='newRa_form'>
	    <div id='trow'>
               <div id='tname'>URL de la RA:</div>
	       <div id='tvalue'>" 
	          . $pkiris['homeURL'] . " <input type='text' name='ra_url_name'  size='20' minlen='7' />
	       </div>
	    </div>
<br/>
	    <div id='trow'>
               <div id='tname'>Nombre:</div>
	       <div id='tvalue'>
	          <input type='text' name='ra_name'  size='40' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Descripci&oacute;n:</div>
	       <div id='tvalue'>
	          <input type='text' name='ra_descr'  size='40' minlen='7' />
	       </div>
	    </div>
	    <div id='trow'>
               <div id='tname'>Ubicaci&oacute;n f&iacute;sica:</div>
               <div id='tvalue'>
	          <input type='text' name='ra_loc'  size='40' minlen='7' />
	       </div>
	    </div>
<br/>
	    <div id='trow'>
               <div id='tname'>Responsable:</div>
               <div id='tvalue'>
	          <input type='text' name='ra_respname'  size='40' minlen='7' />
	       </div>
	    </div>
<br/>
	    <div id='trow'>
               <div id='tname'>Clave de la RA:</div>
               <div id='tvalue'>
	          <input type='password' name='ra_pass'  size='40' minlen='7' />
	       </div>
	     </div>
	     <div id='trow'>
                <div id='tname'>Repita la Clave:</div>
                <div id='tvalue'>
	           <input type='password' name='ra_retype_pass'  size='40' minlen='7' />
		</div>
	     </div>
          </div> <!-- tbox_data_a1 -->
        </div> <!-- tbox -->\n";
	     
	echo "<div id='tbox'>
            <h3 class='head_a2b1'>Dominio/RDN Organizaci&oacute;n</h3>

            <div id='tbox_data_a1'>
	     <div id='trow'>
                <div id='tname'>Dominio (org.es)</div>
                <div id='tvalue'>RDN Organizaci&oacute;n (o=org)</div>
             </div>
	     <div id='trow'>
                <div id='tname'><input type='text' name='domain1'  size='15' /></div>
                <div id='tvalue'><input type='text' name='org1'  size='25' minlen='7' /></div>
             </div>
	     <div id='trow'>
                <div id='tname'><input type='text' name='domain2'  size='15' /></div>
                <div id='tvalue'><input type='text' name='org2'  size='25' minlen='7' /></div>
             </div>
	     <div id='trow'>
                <div id='tname'><input type='text' name='domain3'  size='15' /></div>
                <div id='tvalue'><input type='text' name='org3'  size='25' minlen='7' /></div>
             </div>
	     <div id='trow'>
                <div id='tname'><input type='text' name='domain4'  size='15' /></div>
                <div id='tvalue'><input type='text' name='org4'  size='25' minlen='7' /></div>
             </div>
	      <div id='trow'>
                 <div id='tvalue'>
                    <input class='button' type='button' value='Continuar' onClick='submit_form()'>
                 </div>
              </div>
              <input type='hidden' name='command_newra' value='create_ra'>
           </form>
        </div> <!-- tbox_data_a1 -->
     </div> <!-- tbox -->\n";

   break;						

   case "create_ra":
      // Antes de nada, comprobamos que no exista una RA con el mismo nombre o
      // la misma URL de la que queremos crear
      $newRaUrl = $_POST['ra_url_name'];
      $newRaName = $_POST['ra_name'];
      $filter = "(&(objectClass=pkirisAuthority)(|(pkirisRaUrl=$newRaUrl)(pkirisName=$newRaName)))";
      $justthese = array();
      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
      if ( !$result )
	 $errorCode = "a2b2c1d1e1";
      else if ( $result['count'] != 0 ) 
	 $errorCode = "a2b2c1d2e1";
      else {
         // Creamos el fichero de configuracion de la RA
     	
         // Necesitamos obtener el numero que va a tener la nueva RA.
         // Para ello leemos del fichero index.txt el numero de RAs
         // creadas hasta el momento y le sumamos uno. Ese sera el numero de
         // la RA que estamos creando
         $RasIndex = file_get_contents ($fileVar['RAsIndex']);
         if ( !$RasIndex )
            $errorCode = "a2b2c1d2e7";
         else {
            // Obtenemos el numero de la ultima RA anyadida al sistema.
            // La nueva RA tendra este numero mas uno ('anumero+1')
            settype($RasIndex, integer);
            $RasIndex++;
            $newRaCode = "a".$RasIndex;
            $newRaUrl = $newRaUrl;
            $newRaName = $newRaName;
            $newRaDescr = $_POST["ra_descr"];
            $newRaRespName = $_POST["ra_respname"];
            $newRaLoc = $_POST["ra_loc"];
            $newRaPass = $_POST["ra_pass"];
            $currentDate = date("YmdHis");

            // Creamos el array que contendra todas las claves privadas que vaya 
            // teniendo la RA. Cada vez que cambiemos la clave, la valida sera mas
            // cercana a la fecha actual, pero siempre menor que ella
            $raPrivKeyArray = array();

            $raStringFile = "<?php\n\nglobal \$raNum;\nglobal \$raName;\nglobal \$raPrivKey;\nglobal \$raDomains;\n\n\$raNum = \"$newRaCode\";\n\$raName = \"$newRaName\";\n\$raUrl = \"$newRaUrl\";\n\n\$raPrivKey = \"$newRaPass\";\n\n\$raDomains = array (\n";
      
            //if ((isset($_POST["domain1"])) && (isset($_POST["domain2"])) && (isset($_POST["domain3"])) && (isset($_POST["domain4"]))) {
            if (($_POST['domain1'] != NULL) && ($_POST['domain2'] != NULL) && ($_POST['domain3'] != NULL) && ($_POST['domain4'] != NULL)) {
               $raStringFile = $raStringFile ."\"".$_POST['domain1']."\" => array (\n\"domain\" => \"".$_POST['org1'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
               $raStringFile = $raStringFile ."\"".$_POST['domain2']."\" => array (\n\"domain\" => \"".$_POST['org2'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
	       $raStringFile = $raStringFile ."\"".$_POST['domain3']."\" => array (\n\"domain\" => \"".$_POST['org3'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
	       $raStringFile = $raStringFile ."\"".$_POST['domain4']."\" => array (\n\"domain\" => \"".$_POST['org4'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
            }
            else {
	       if (($_POST['domain1'] != NULL) && ($_POST['domain2'] != NULL) && ($_POST['domain3'] != NULL)) {
	          $raStringFile = $raStringFile ."\"".$_POST['domain1']."\" => array (\n\"domain\" => \"".$_POST['org1'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
		  $raStringFile = $raStringFile ."\"".$_POST['domain2']."\" => array (\n\"domain\" => \"".$_POST['org2'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
		  $raStringFile = $raStringFile ."\"".$_POST['domain3']."\" => array (\n\"domain\" => \"".$_POST['org3'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
      	       }
	       else {
	          if (($_POST['domain1'] != NULL) && ($_POST['domain2'] != NULL)) {
		     $raStringFile = $raStringFile ."\"".$_POST['domain1']."\" => array (\n\"domain\" => \"".$_POST['org1'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
		     $raStringFile = $raStringFile ."\"".$_POST['domain2']."\" => array (\n\"domain\" => \"".$_POST['org2'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
	          }
	          else {
		     $raStringFile = $raStringFile ."\"".$_POST['domain1']."\" => array (\n\"domain\" => \"".$_POST['org1'].",\",\n\"validDomainRegexp\" => \".*[^\.$]\",\n\"admin\" => \"a1b1\" ),\n";
	          }
	       }
            }
	  
            $raStringFile = $raStringFile . ");\n\n\$raPrivKeyArray['$newRaCode']['$currentDate'] = \"$newRaPass\";\n\n?>";
            $raConfFile = fopen($dirVar['conf']."php/$newRaUrl".".conf", "w+");
	    if ( !$raConfFile )
	       $errorCode = "a2b2c1d2e2";
            else {
               $result = fputs($raConfFile, $raStringFile);
               $fc = fclose($raConfFile);
               if ( !$fc )
		  $errorCode = "a2b2c1d2e4";
               else { 
                  if ( !$result )
                     $errorCode = "a2b2c1d2e3";
                  else {      
                     // Creamos la entrada en el Ldap
                     $info["objectClass"][0]="top";
                     $info["objectClass"][1]="irisObject";
                     $info["objectClass"][2]="pkirisAuthority";
                     $info[$ldapVar['rdnAttr']]=$newRaCode;
                     $info["pkirisID"]=$newRaCode;
                     $info["pkirisName"]=$newRaName;
                     $info["pkirisRaUrl"]=$newRaUrl;
                     $info["pkirisCounter"]="0";
                     $info["pkirisCopaID"]=$newRaCode;
                     $info["description"]=$newRaDescr;

                     // Guardamos la informacion de la RA
                     $r=ldap_add_info($ldapVar['rdnAttr']."=".$newRaCode.",".$ldapVar['base'], $info);
   	             if ( !$r ) 
 			$errorCode = "a2b2c1d1e2";
		     else {
                        // Guardamos en el fichero de indices el numero
                        // de la RA actual
                        $fd = fopen($fileVar['RAsIndex'],"w");
                        if ( !$fd )
                           $errorCode = "a2b2c1d2e2";
                        else {
                           $r = fputs($fd,$RasIndex);
                           if ( !$r ) 
                              $errorCode = "a2b2c1d2e3";
                           fclose($fd);
                        } 
                        // Creamos el link simbolico para el apache
   	                $linkResult = symlink($dirVar['web']."pki", $dirVar['web'].$newRaUrl);
	                if ( !$linkResult ) 
			   $errorCode = "a2b2c1d2e5";
			else {
	                   // Exportamos la clave privada de la RA
         	          $exportResult = exportRaPrivKey($newRaCode, $currentDate);
	                  if ( !$exportResult ) 
			     $errorCode = "a2b2c1d2e6";
			  else {
                              echo "<p>La Autoridad de Registro \"$newRaName\" ha sido creada con &eacute;xito.
            	             Para su total funcionamiento tendr&aacute; que generar una redirecci&oacute;n en su servidor web que apunte de /$newRaUrl/ a " . $pkiris['homeURLs'] . "$newRaUrl. Para m&aacute;s informaci&oacute;n consulte el manual de usuario.</p>";
			     // Registramos la accion en el fichero de log
                             $pkiLog['status'] = "newRa";
                             $pkiLog['eee'] = $newRaCode;
                             $pkiLog['user'] = "PKIAdmin";
                             $pkiLog['error'] = $errorCode;
                             writeLog ($pkiLog);
	                   }
                        } 
                     }   
		  }
	       }
	    }
         }	          
      }
   
  break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error en la creaci&oacute;n de la Autoridad de Registro $newRaName </h2>\n";
   $pkiLog['status'] = "newRa";
   $pkiLog['eee'] = $newRaCode;
   $pkiLog['user'] = "PKIAdmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>
